use crate::{Float, Numeric, Primitive};

#[derive(Debug, Copy, Clone)]
pub struct Quaternion<T: Float + Numeric + Primitive> {
    pub r: T,
    pub i: T,
    pub j: T,
    pub k: T,
}

impl<T: Float + Numeric + Primitive> Default for Quaternion<T> {
    fn default() -> Self {
        let zero = unsafe { T::whole(0) };
        Self {
            r: zero,
            i: zero,
            j: zero,
            k: zero,
        }
    }
}
